% !TeX spellcheck = en_GB
%%%%%%%%%%%%%%%%%%%%% Packages calls %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\documentclass[british, a4paper, 10pt]{article}									%%
\usepackage[utf8]{inputenc}														%%
\usepackage[T1]{fontenc}														%%
\usepackage{textcomp}															%%
\usepackage{babel}																%%
\usepackage{lmodern}															%%
\usepackage[top=3cm, bottom=3cm, left=3cm, right=3cm]{geometry}					%%
\usepackage{fancyhdr}															%%
\usepackage{amsfonts}															%%
\usepackage{mathtools}															%%
\usepackage{amssymb}															%%
\usepackage{hyperref}															%%
\usepackage{booktabs}															%%
\usepackage{graphicx}															%%
\usepackage{listings}															%%
\usepackage{color}																%%
\definecolor{dkgreen}{rgb}{0,0.6,0}												%%
\definecolor{gray}{rgb}{0.5,0.5,0.5}											%%
\definecolor{mauve}{rgb}{0.58,0,0.82}											%%
\newlength{\picwidth}															%%
\setlength{\picwidth}{0.8\linewidth}											%%
%%%%%%%%%%%%%%%%%%%%% Commands Definition %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\newcommand{\N}{\mathbb{N}}														%%
\newcommand{\Z}{\mathbb{Z}}														%%
\newcommand{\Q}{\mathbb{Q}}														%%
\newcommand{\R}{\mathbb{R}}														%%
\newcommand{\C}{\mathbb{C}}														%%
\renewcommand{\vec}{\overrightarrow}											%%
\newcommand{\Matlab}{\textsc{Matlab}}											%%
\newcommand{\barre}{\vspace{3pt}\hrule\vspace{6pt}}								%%
\newcommand{\HRule}{\rule{\linewidth}{0.5mm}}									%%
\author{\coauthorOne - \coauthorTwo}											%%
\title{\betitle}																%%
\hypersetup{bookmarks=true,														%%
			pdfborder={0 0 0},													%%
			pdftoolbar=false,													%%
			citecolor=blue		}												%%
\lstset{frame=tb,																%%
		language=Python,														%%
		aboveskip=3mm,															%%
		belowskip=3mm,															%%
		showstringspaces=false,													%%
		columns=flexible,														%%
		basicstyle={\small\ttfamily},											%%
		numbers=none,															%%
		numberstyle=\tiny\color{gray},											%%
		keywordstyle=\color{blue},												%%
		commentstyle=\color{dkgreen},											%%
		stringstyle=\color{mauve},												%%
		breaklines=true,														%%
		breakatwhitespace=true,													%%
		tabsize=4																%%
}																				%%
%%%%%%%%%%%%%%%%%%%%% Head and foot definition %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\pagestyle{fancy}																%%
	\lhead{\matiere}		\chead{}	\rhead{\betitle}						%%
	\renewcommand{\headrulewidth}{0.4pt}										%%
	\renewcommand{\footrulewidth}{0.4pt}										%%
	\lfoot{\coauthorOne}\cfoot{\thepage/\pageref{LastPage}}	\rfoot{\coauthorTwo}%%
																				%%
\fancypagestyle{plain}{															%%
	\lhead{}	\chead{}	\rhead{}											%%
	\renewcommand{\headrulewidth}{0pt}											%%
	\renewcommand{\footrulewidth}{0pt}											%%
	\lfoot{}	\cfoot{}	\rfoot{}}											%%
%%%%%%%%%%%%%%%%%%%%% Title page %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\newcommand{\maketitlepage}{													%%
\begin{titlepage}																%%
	\pagestyle{plain}															%%
	\begin{large}																%%
		\begin{center}															%%
			\textsc{\LARGE \matiere}\\[1.5cm]									%%
																				%%
			\textsc{\Large \group}\\[0.5cm]										%%
																				%%
			\HRule \\[0.4cm]													%%
			{\huge \bfseries \betitle  \\[0.4cm]}								%%
			\HRule \\[1.5cm]													%%
																				%%
			\noindent															%%
			\begin{minipage}{0.4\textwidth}										%%
				\begin{flushleft} \large										%%
					\emph{Student:}\\											%%
					\medskip													%%
					\coauthorOne\\												%%
					\medskip													%%
					\coauthorTwo												%%
				\end{flushleft}													%%
			\end{minipage}														%%
			\begin{minipage}{0.4\textwidth}										%%
				\begin{flushright} \large										%%
					\emph{Teacher:}\\											%%
					\medskip													%%
					\teacherOne\\												%%
					\medskip													%%
					\teacherTwo													%%
				\end{flushright}												%%
			\end{minipage}\\													%%
																				%%
			\vspace{2\baselineskip}  											%%
			{\Large \duedate}													%%
		\end{center}															%%
		\vfill																	%%
		\begin{large}															%%
			\introText															%%
		\end{large}																%%
	\end{large}																	%%
	\tableofcontents															%%
\newpage																		%%
$~$																				%%
\end{titlepage}																	%%
\newpage																		%%
}																				%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%% Doc Info %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\newcommand{\betitle}		{Lab Report : ECG Filtering}						%%
\newcommand{\matiere}		{ENG5027 - Digital Signal Processing}			  	%%
\newcommand{\coauthorOne}	{R\'emy \textsc{Chatel}}							%%
\newcommand{\coauthorTwo}	{2411062C}											%%
\newcommand{\teacherOne}	{Bernd \textsc{Porr} \\ $~$}						%%
\newcommand{\teacherTwo}	{$~$}												%%
\newcommand{\duedate}		{Due November, 12th 2018}							%%
\newcommand{\group}			{University of Glasgow}								%%
\newcommand{\introText}		{													%%
\paragraph*{\emph{Abstract}}													%%
This laboratory cover the recording, filtering and processing of 				%%
electrocardiograms using FIR filters as band stop, high pass or matched filters %%
}																				%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{document}	
\maketitlepage

\section{ECG cleaning}
\subsection{Motivation}
\paragraph{} Electrocardiogram (ECG) is an essential part of medical diagnostic as it reveals the amount of stress the body is currently experiencing (sports, diseases, fever, ...).

However, signal acquisition often delivers	 a noisy signal, polluted by the ambient 50Hz and DC drift. Hence the need to clean the ECG before displaying it to the GP to avoid wrong diagnostics. 

First thing is to remove the DC component of the signal in order to centre it around 0. To do that a high pass filter with a cut-off frequency of 1Hz will be used.

Then we can notice that the 50Hz noise is significantly affecting the recording. Therefore a notch filter with a cut-off at 50Hz and a bandwidth of 5Hz will be used to remove it.

\paragraph{} An example of recording and a zoomed-in version is shown on Figure \ref{fig:os} with its DFT to show that the DC and 50Hz component affect the recording.

\begin{figure}[hbp]
	\centering
	\includegraphics[width=\picwidth]{media/original_still_full.pdf}\\
	\includegraphics[width=\picwidth]{media/original_still_zoom.pdf}
	\caption{ECG recorded @ 1kHz with USB-DUX and comedirecord and zoom-in}
	\label{fig:os}
\end{figure}

The recording are made using the USB-DUX Analog to Digital Converter and the \texttt{comedirecord} software. 

\subsection{Implementation}
\paragraph{} To implement the filter, an FIR filter will be used. It will combine the $1Hz$ high-pass and the $50~Hz$ ($B=5~Hz$) band-stop. 

The FIR filter is based around circular buffer implementation, based on the C++ implementation of the code written by Bernd \textsc{Porr} and Graeme \textsc{Hattan} (\url{https://github.com/berndporr/fir1}).

\begin{lstlisting}
	output   = 0.                               # Initialising the output
	i_coeff  = 0                                # Start index of coefficients
	i_buffer = self.offset                      # Start index of buffer
	self.buffer[i_buffer] = value               # Storing the new value in buffer
	
	while i_buffer >= 0:                        # First part of buffer
												# Applying the filter
	output += self.buffer[i_buffer] * self.coeffs[i_coeff]
	i_coeff  += 1                           	# Going through the coeffs
	i_buffer -= 1                           	# Going through buffer backward
	
	i_buffer = self.taps -1                     # Going to the end of buffer
												# to reach its second part
	while i_coeff < self.taps:                  # Second part of buffer
												# Applying the filter
	output += self.buffer[i_buffer] * self.coeffs[i_coeff]
	i_coeff  += 1                           	# Going through the coeffs
	i_buffer -= 1                          		# Going through buffer backward
	
	self.offset += 1                            # Incrementing offset for next
												# for next processing
	if self.offset >= self.taps:                # Offset must stay within buffer
	self.offset = 0
\end{lstlisting}

The coefficients are computed by another class \texttt{StdFilter} which represents a standard (band-pass, band-stop, high-pass or low-pass) filter. During its creation, the object can receive any combination of ideal filters, and their frequency response will be multiplied to have one frequency response.

The IFFT is applied to transform the ideal frequency response into an impulse response so as to generate the coefficients for the FIR filter. Then, a window is applied to mitigate the boundary effects of the IFFT. Best results were obtained using the Hamming window.

The result FIR filter is shown on Figures \ref{fig:firf} and \ref{fig:firz} (zoomed-in) page \pageref{fig:firf}. The filter achieve a $-120~dB$ damping at the desired frequency.

\begin{figure}[hbp]
	\centering
	\includegraphics[width=\picwidth]{media/FIR_filter.pdf}
	\caption{FIR Filter to remove DC and 50Hz noise}
	\label{fig:firf}
\end{figure}

\begin{figure}[hbp]
	\centering
	\includegraphics[width=\picwidth]{media/FIR_filter_zoom.pdf}
	\caption{FIR Filter to remove DC and 50Hz noise -- Zoom}
	\label{fig:firz}
\end{figure}

\subsection{Results}

The result off the filter on the ECG is shown on Figure \ref{fig:cleaning} page \pageref{fig:cleaning} and Figure \ref{fig:cleaning_zoom} page \pageref{fig:cleaning_zoom}. The DC drift has been removed and the $50~Hz$ noise has been dampened enough. However, a noise is still polluting the signal. The $50~Hz$ noise had an amplitude of $200~dB$ initially, and the filter could only do in practice a damping of $70~dB$.

\begin{figure}[hbp]
	\centering
	\includegraphics[width=\linewidth]{media/original_still_full.pdf}\\
	\includegraphics[width=\linewidth]{media/cleaned_still_full.pdf}
	\caption{Original (top) vs Filtered (bottom)}
	\label{fig:cleaning}
\end{figure}

\begin{figure}[hbp]
	\centering
	\includegraphics[width=\linewidth]{media/original_still_zoom.pdf}\\
	\includegraphics[width=\linewidth]{media/cleaned_still_zoom.pdf}
	\caption{Original (top) vs Filtered (bottom) zoomed-in}
	\label{fig:cleaning_zoom}
\end{figure}

\paragraph{}
The main drawback of this filter is the sensitivity to the frequency resolution. A high resolution frequency (near zero) would give more strength to the filter but it would mean an large amount of taps.

For instance, the frequency resolution here is $0.5~Hz$, therefore, at a sampling frequency of $1~kHz$ the equation \ref{eq:taps} gives 2000 taps for this filter. Meaning there is a 2 seconds delay between the input and what is shown on the output.

\begin{equation}
	M = \frac{F_s}{\Delta F}
\end{equation}
\label{eq:taps}

Concerning timing, it takes $53.335~s$ to process a $60.302~s$ recording, which means an average time of $0.88~ms$ per sample. The sampling frequency being $1~Hz$ , the time between to sample is $1~ms$. Therefore, with this sampling frequency and a frequency resolution of $0.5~Hz$ this filter could do real-time processing.

\subsection{Conclusion}
\paragraph{} The FIR filter has been successfully implemented and gives a much better reading of the heart beats than before. This implementation would be fast enough to work in real time.


\section{Heartbeat matching}
\subsection{Motivation}
\paragraph{} In this part of the laboratory, the objective is to process an ECG recording to extract the instantaneous heart rate of the subject. This would allow a GP for instance to record the patient heart rate into its file.

\paragraph{} An FIR matched filter will be used to compare the ECG to a template found in a clean ECG. Then, by measuring the time elapsed between to matches, it is possible to compute a frequency and therefore the heart rate (in $bpm$).

\paragraph{} The template is a single heart beat, which has a duration of $500$ to $600~ms$. The template used is shown in Figure \ref{fig:template} and has been extrated from the the \texttt{ecg\_1.dat} file after it has been cleaned.

\begin{figure}[hbp]
	\centering
	\includegraphics[width=\picwidth]{media/heartbeat_template.pdf}
	\caption{Heart beat template}
	\label{fig:template}
\end{figure}

\noindent Waves P, Q R and S are visible clearly, but the T wave does not show well on this recording.

\subsection{Implementation}
\paragraph{} The template is first read from a file, then time-reversed and used as the coefficients of an FIR filter. Then, the recording is filtered and the result is squared to improve Signal-to-Noise-Ratio.

\begin{lstlisting}
def match(self, pattern, threshold_factor):
	# Finding a template from an external recording or from a slice of the recording
	if type(pattern) == tuple:
		i_srt, i_end = pattern
		template = self.dat[i_srt:i_end]
	else:
		template = np.loadtxt(pattern)
	template = template[::-1]                           # Time reverse the template
	matched_filter = fir.FIRFilter(template)            # Create FIR with the template
	self.matched = matched_filter.process(self.dat)# Process the signal
	self.matched = self.matched ** 2                    # Square to increase SNR
\end{lstlisting}

The resulting recording is show in Figure \ref{fig:matched} with the threshold, which is set on the maximum divided by 10. 

\begin{figure}[hbp]
	\centering
	\includegraphics[width=\picwidth]{media/matched_still.pdf}
	\caption{Matched filter result}
	\label{fig:matched}
\end{figure}XX

When the the threshold is reached, the program looks for the end of the peak then, perform a maximum search within the peak and record the index at which this maximum happens.

This value is then converted to a time and the heart rate array is computed by computing the difference between two consecutive timestamps of heart beat.


\begin{lstlisting}
max_list = []                                       # Create list for index of max
flag = False                                        # Create a detection flag
i_min, i_max = 0, 0                                 # Set indexes to zero
for i in range(length):                             # Run through the data
	if not(flag) and self.matched[i]>threshold:     # On rising edge of a peak
		flag = True                                 # Set detection flag to true
		i_min = i                                   # Record index of start
	if flag and self.matched[i]<threshold:          # On faling edge of a peak
		flag = False                                # Set detection flag to false
		i_max = i                                   # Record index of end
		# Find the index of the maximum between i_min and i_max
		max_list.append(self.matched[i_min:i_max+1].argmax() + i)
beats = np.array(max_list)                          # Convert to array
self.rates = np.zeros(len(beats)-1)                 # Create rates array
for i in range(len(self.rates)):               		# Populate the array
	# Compute the rates in bpm
	self.rates[i] = (60 * self.Fs) /(beats[i+1] - beats[i])
self.rates_time = beats[1:] / self.Fs				# Creating the time axis
for i in range(len(self.rates)):                    # Weeding out weird rates
	if self.rates[i] < 30 or self.rates[i] >200:
		self.rates[i] = 0
return self.rates
\end{lstlisting}


\subsection{Results}
The result is shown on Figure \ref{fig:heart} with the addition of the average heart rate over this recording.


\begin{figure}[hbp]
	\centering
	\includegraphics[width=\picwidth]{media/heart_rate_still.pdf}
	\caption{Instantaneous heart rate}
	\label{fig:heart}
\end{figure}

This recording was taken on a subject at rest, before any physical activity, therefore a value of $87~bpm$ on average is normal (source : \url{https://www.heart.org/en/health-topics/high-blood-pressure/the-facts-about-high-blood-pressure/all-about-heart-rate-pulse})

\subsection{Conclusion}
The heart rate was extracted from the recording and by setting the frequency resolution to $0.55~Hz$ the program was able to process the sample in under $1~ms$. Therefore, real time processing would be possible for this implementation in python. 

\newpage
\appendix
\section{Codes}
\noindent All source files can be found at the following address : \url{https://gitlab.com/r.chatel/uog_dsp}

\paragraph{Source files} :

\noindent FIR filter classes
\lstinputlisting{../FIR.py}
\label{cod:fir}
\noindent ECG class
\lstinputlisting{../ECG.py}
\label{cod:ecg}
\noindent Main script for ECG cleaning
\lstinputlisting{../ecg_filter.py}
\label{cod:ecg_filter}
\noindent Main script for heart rate detection
\lstinputlisting{../hr_detect.py}
\label{cod:main_hr}

\label{LastPage}
\end{document}
